# Copyright 2022-2024 ETSI TeraFlowSDN - TFS OSG (https://tfs.etsi.org/)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import grpc, logging
from common.Constants import ServiceNameEnum
from common.Settings import get_service_host, get_service_port_grpc
from common.tools.client.RetryDecorator import retry, delay_exponential
from pcep.service.tools.protos.grpcService_pb2 import LSPdb_Request, Session_Request, commandRequest 
from pcep.service.tools.protos.grpcService_pb2_grpc import pceServiceStub

LOGGER = logging.getLogger(__name__)
MAX_RETRIES = 15
DELAY_FUNCTION = delay_exponential(initial=0.01, increment=2.0, maximum=5.0)
RETRY_DECORATOR = retry(max_retries=MAX_RETRIES, delay_function=DELAY_FUNCTION, prepare_method_name='connect')
PORT = 10060    

class GrpcPcepClient:
    def __init__(self, host="192.168.159.225", port=None):
        if not host: host = get_service_host(ServiceNameEnum.PCEP)
        #if not port: port = get_service_port_grpc(ServiceNameEnum.PCEP)
        if not port: port = PORT                                                                #Maybe should not be hardcoded
        self.endpoint = '{:s}:{:s}'.format(str(host), str(port))
        LOGGER.warning('Creating channel to {:s}...'.format(str(self.endpoint)))
        self.channel = None
        self.stub = None
        self.connect()
        LOGGER.warning('Channel created')

    def connect(self):
        #LOGGER.warning('IAM IN CONNECT')
        LOGGER.warning('Creating channel to {:s}...'.format(str(self.endpoint)))
        self.channel = grpc.insecure_channel(self.endpoint)
        self.stub = pceServiceStub(self.channel)
        LOGGER.warning('Channel created')
        
    def close(self):
        #LOGGER.warning('IAM IN CLOSE')
        if self.channel is not None: self.channel.close()
        self.channel = None
        self.stub = None
        
    @RETRY_DECORATOR
    def showSessions(self):
        requestsessions = Session_Request()
        responsesessions = self.stub.getSessionsInfo(requestsessions)
        LOGGER.warning("IAM IN SHOWSESSIONS: {:s}".format(str(responsesessions)))
        return responsesessions

    @RETRY_DECORATOR
    def showLSPDB(self):
        LOGGER.info("IAM IN SHOWLSPDB")
        requestlsp = LSPdb_Request()
        LOGGER.info("LSPDB REQUEST")
        responselsp = self.stub.getLSPdb(requestlsp)
        LOGGER.warning("IAM IN SHOWREQUEST: {:s}".format(str(responselsp)))
        return responselsp
    
    @RETRY_DECORATOR
    def sendUpdate(self, data):
        #LOGGER.warning("IAM IN SEND UPDATE")
        commandrequest = commandRequest()  # Create an instance without passing data to __init__
        commandrequest.command = data
        #LOGGER.warning("This is Command Request: %s", str(commandrequest))
        commandresponse = self.stub.update(commandrequest)
        #LOGGER.warning("This is Command Response: %s", str(commandresponse))
        #LOGGER.warning("Success: %s", str(commandresponse.success))
        #LOGGER.warning("Error Message: %s", str(commandresponse.error_message))
        return commandresponse
